//+------------------------------------------------------------------+
//|                             ibs_rsi_cci_v3 alert.mq4             |
//|                                                                  |
//|         modified on May 2011 by nlenz                            |
//|      requires ibs_rsi_cci_v3 indicator in the indicators folder  |
//+------------------------------------------------------------------+
#property copyright "nlenz"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_width1 3
#property indicator_color2 Red
#property indicator_width2 3

//#include <WinUser32.mqh>
//---- input parameters
extern int porog = 50;
extern bool Alerts=false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//---- variables
int sigCurrent=0;
int sigPrevious=0;
double pipdiffCurrent=0;
double pipdiffPrevious=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   /*SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);*/
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,ExtMapBuffer1);
   //SetIndexEmptyValue(2,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,ExtMapBuffer2);
  // SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double rsi_sig=0;
   bool entry=false;
   double entry_point=0;
   double ibs = 0.0;
   
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   //---- main loop
   for(int i=limit - 1; i>0; i--)
   {
     //---- ma_shift set to 0 because SetIndexShift called abowe
     //ExtMapBuffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
     //ExtMapBuffer2[i]=iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
     //rsi_sig = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, i);
     
     //pipdiffCurrent=(ExtMapBuffer2[i]-ExtMapBuffer1[i]);
     
     ibs = iCustom(NULL, 0, "ibs_rsi_cci_v3", 5, 0, 7.0, true, 14, 0, 9.0, true, 14, 0, 1.0, true, 0, porog, false, true, 25, 3, 0, 0, i);
     
     if (ibs > 0)
      sigCurrent = 1;
     else  
      sigCurrent = -1; // down
     
     //Comment("pipdiffCurrent = "+pipdiffCurrent+" ");
     /*if (pipdiffCurrent>0 && rsi_sig<50) 
     {
       sigCurrent = 1;  //Down
     }
     else if (pipdiffCurrent<0 && rsi_sig>50)
     {
       sigCurrent = 2;  //Up
     }*/
/*
     if (pipdiffCurrent>0) 
     {
       sigCurrent = 1;  //Up
     }
     else if (pipdiffCurrent<0)
     {
       sigCurrent = 2;  //Down
     }
*/     
      ExtMapBuffer1[i] = 0.0;
      ExtMapBuffer2[i] = 0.0;
     if (sigCurrent==1 && sigPrevious==-1)
     {
        ExtMapBuffer1[i] = Low[i]-1.5*iATR(NULL,0,4,i);
        //ExtMapBuffer3[i] = Ask;
        entry=true;
        entry_point=Close[i];
     } 
     else if (sigCurrent==-1 && sigPrevious==1)
     {
        ExtMapBuffer2[i] = High[i]+1.5*iATR(NULL,0,4,i);
        //ExtMapBuffer4[i] = Bid;
        entry=true;
        entry_point=Close[i];
     }


     sigPrevious=sigCurrent;
     //pipdiffPrevious=pipdiffCurrent;
   }

   //----
   if(Alerts && entry)
   {
     //PlaySound("alert.wav");
     if (sigCurrent==1)
     {
        Alert("Entry point: buy at ",entry_point," ",Symbol()," M", Period());
     }
     else if (sigCurrent==2)
     {
        Alert("Entry point: sell at ",entry_point," ",Symbol()," M",Period());
     }

     entry=false;
   }


//----
   return(0);
  }
//+------------------------------------------------------------------+

